stages:
- build

variables:
  DOCKER_TLS_CERTDIR: ""
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://docker:2375

build_image_main_or_tagged:
  image: "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:27.5.1"
  services:
    - name: "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:27.5.1-dind"
      alias: docker
  stage: build
  rules:
  - if: '$CI_COMMIT_REF_NAME =~ /^(main|devel|v[0-9]+\.[0-9.]+)$/'
    when: always
  - when: never
  before_script:
    - mkdir $HOME/.docker
    - docker login "$CI_REGISTRY" -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD"
    - docker login -u "$CI_DEPENDENCY_PROXY_USER" -p "$CI_DEPENDENCY_PROXY_PASSWORD" "$CI_DEPENDENCY_PROXY_SERVER"
    # The following is magic to get the dockerhub images using the gitlab dependency proxy without specifying these images in the Dockerfile
    # This allows use to ignore the dockerhub rate limit while allowing security analyzers to still pick up dockerhub changes
    - for i in $(grep FROM Dockerfile | awk '{print $2}' | sort | uniq); do docker pull "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/${i}"; docker tag "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/${i}" "${i}"; done
  script:
    # Cut out the "v" of version strings
  - 'if $(echo "${CI_COMMIT_REF_NAME}" | grep -Eq "^(v[0-9]+\.[0-9.]+)"); then export IMAGE_TAG="${CI_COMMIT_REF_NAME#v}"; else export IMAGE_TAG="$CI_COMMIT_REF_NAME"; fi'
  - 'export IMAGE_REF_BASE="${CI_REGISTRY_IMAGE}:${IMAGE_TAG}"'
  - 'docker build -t "${IMAGE_REF_BASE}" -f Dockerfile .'
  - 'docker push "${IMAGE_REF_BASE}"'

build_image_mr:
  image: "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:27.5.1"
  services:
    - name: "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/docker:27.5.1-dind"
      alias: docker
  stage: build
  rules:
  - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
    when: always
  - when: never
  before_script:
    - mkdir $HOME/.docker
    - docker login "$CI_REGISTRY" -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD"
    - docker login -u "$CI_DEPENDENCY_PROXY_USER" -p "$CI_DEPENDENCY_PROXY_PASSWORD" "$CI_DEPENDENCY_PROXY_SERVER"
    # The following is magic to get the dockerhub images using the gitlab dependency proxy without specifying these images in the Dockerfile
    # This allows use to ignore the dockerhub rate limit while allowing security analyzers to still pick up dockerhub changes
    - for i in $(grep FROM Dockerfile | awk '{print $2}' | sort | uniq); do docker pull "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/${i}"; docker tag "${CI_DEPENDENCY_PROXY_GROUP_IMAGE_PREFIX}/${i}" "${i}"; done
  script:
    # Cut out the "v" of version strings
    - 'if $(echo "${CI_COMMIT_REF_NAME}" | grep -Eq "^(v[0-9]+\.[0-9.]+)"); then export IMAGE_TAG="${CI_COMMIT_REF_SLUG#v}"; else export IMAGE_TAG="$CI_COMMIT_REF_SLUG"; fi'
    - 'export IMAGE_REF_BASE="${CI_REGISTRY_IMAGE}:${IMAGE_TAG}"'
    - 'docker build -t "${IMAGE_REF_BASE}" -f Dockerfile .'
    - 'docker push "${IMAGE_REF_BASE}"'
